<template>
  <div>
    <vue-element-loading :active="loading" spinner="spinner" color="#FF6700" :is-full-screen="true" backgroundColor="rgba(255,255,255,.25)"/>
    <v-toolbar color="primary" dark fixed app flat  scroll-off-screen>
        <v-toolbar-side-icon @click.stop="drawer = !drawer"></v-toolbar-side-icon>
        <v-toolbar-title>
            <v-breadcrumbs dark :items="breadcrumbItems" divider=">" class="cursive breadcrumb" />
        </v-toolbar-title>
        
        <v-spacer />
        
        <SearchMenu />
        
        <v-btn dark flat right small icon class="pr-0  mr-0" @click="refresh()">
          <v-icon style="vertical-align:bottom;font-size:20px">refresh</v-icon>
        </v-btn>
    </v-toolbar>
    
    <NavDrawer :drawer="drawer" @update="drawer = $event" />
    
    <v-content class="archive">
      <v-container fluid grid-list-sm>
        <v-layout row wrap fill-height>
            <v-flex xs12 v-if="hasQuery">
              <v-layout row wrap>
                <v-flex xs12 sm6 md4 v-for="(item) in items" :key="item.id" >
                  <ApplicationCard 
                      noDescriptionMarginTop="mt-4"
                      :draggable="false" 
                      :hideActions="hideActions" 
                      @remove="removeItem(item)"
                      @unarchive="unarchive(item)"
                      :item="item" class="ma-2" />
                </v-flex>
              </v-layout>
            </v-flex>
            <v-flex v-else xs12 class="text-xs-center pt-5 pb-5 headline" style="color: white; opacity: .8; font-size: 110%">
                {{$i18n.t('search.noresults')}}
            </v-flex>
        </v-layout>    
        </v-container>
    </v-content>
    
 </div>
</template>

<script>
import moment from 'moment'
import VueElementLoading from 'vue-element-loading'
import NavDrawer from '../components/NavDrawer.vue' 
import SearchMenu from '../components/SearchMenu.vue' 
import ApplicationCard from '../components/application/board/ApplicationCard';
export default {
  name: 'archive',
  components: {
    ApplicationCard,
    NavDrawer,
    SearchMenu,
    VueElementLoading
  },
  props: {
    hideActions: {
        type: Array,
        default: () => ['archive', 'edit', 'notes']
    },
    numberOfColumns: {
        default: 2
    }
  },    
  data() {
    return {
        loading: false,
        pageSize: 6,
        currentPage: 0,
        hasMore: true,
        drawer: false,
        items: [],
        loader: null
    }
  },
  computed: {
     hasQuery() { 
          return Object.keys(this.$route.query).length > 0 
     },
     breadcrumbItems() {
        return [{
          text: this.$i18n.t("menu.archive"),
          disabled: true
        }]
     }
  },
  methods: {
    refresh() {
         this.currentPage = 0
         this.items.length = 0
         this.hasMore = true
         this.loadPage()
    },
    async unarchive(item) {
        let event = null

        if ( item.events ) {
            let events = item.events.sort((a, b) => {
                moment(b.date).valueOf() - moment(a.date).valueOf()
            })
        
            for ( let i = 0; i < events.length; i++ ) {
                const currentElem = events[i];
                if ( currentElem.field != 'status' ) {
                    continue;
                }
                const newValue = currentElem.newValue
                if ( !!newValue.statusValue && newValue.statusValue == 'CLOSED' ) {
                    event = events[i]
                    break;
                }
            }
        }
        
        const status = event ? event.oldValue.statusValue : 'SAVED';   
     
        const index = this.items.findIndex((elem) => { return elem.id == item.id });
        
        this.items.splice(index, 1)
        try {
            await this.$api.patchApplication(item.id, { status })
        }
        catch ( e )  {
            this.$logger.error(e.message);
            //TODO alert the user
            this.items.push(index, 0, item)
        }
    },
    async removeItem(item, index) {
      this.items.splice(index, 1)
      try {
        await this.$api.deleteApplication(item)
      }
      catch ( e )  {
        this.$logger.error(e.message);
        //TODO alert the user
        this.items.push(index, 0, item)
      }
    },
    loadPage() {
        if (this.loading || !this.hasQuery || !this.hasMore ) {
            return;
        }
        this.loading = true;
        this.$api.getApplications(Object.assign({}, this.$route.query, {size: this.pageSize, page: this.currentPage}))
            .then((result) => {
                this.items = this.items.concat(result.content)
                this.currentPage += 1
                this.hasMore = this.currentPage*this.pageSize < result.totalElements    
            })
            .catch((e) => {
                this.$logger.error(e);
            })  
            .finally(() => {
                this.loading = false;
                if ( this.loader) {
                    this.loader.hide()
                }
            })
    }
  },
  watch:{
    $route (){
        this.currentPage = 0
        this.items.length = 0
        this.hasMore = true
        this.loadPage();
    }
  },
  mounted() {
    this.loadPage();
    window.onscroll = () => {
      let bottomOfWindow = document.documentElement.scrollTop + window.innerHeight === document.documentElement.offsetHeight;
      if (bottomOfWindow) {
        this.loadPage()
      }
    };
  }
}
</script>

<style>
.filler {
  background-image: linear-gradient(rgba(255, 255, 255, 0.2), rgba(255, 255, 255, 0)); 
  border-radius: 2px;
 }
</style>

